/* This files is print_config.cc
   Member function of Lattice class. It prints
   the configuration of the lattice.
   By Teck Leong Tan
*/

#include "lattice.h"

void Lattice::print_config(fstream& config)
{ //print noccupancy[] in a file.
  //Loop over cell (ijk)
  for (int ijk=0; ijk<nsize; ijk++)
  { //Loop over sublattice
    for (int l=0; l<num_sublat;l++)
    {
      config<<" "<<noccupancy[ijk].site[l].atomtype;
    }
    for (int i=ndim-1;i>0;i--)
    {
      //If the end of the box's side is reached, create a new line
      if ((ijk+1)%factor[i]==0) { config<<endl; }
      
    }
  }//end for (int ijk=0; ijk<nsize; ijk++)
  return;
}

//EOF
