//This file is read_lat_vec.cc
//Definition of member function of Lattice class.
//The func. reads in the lattice vectors 
//By Teck Leong Tan

#include "trans_vectors.h"

void Trans_vectors::read_lat_vec(string const &dir, int ndim)
{
  vector<double> tempvec;
  tempvec.assign(ndim,0);
  double mag;
  int sublat_count;
  string file;
  if (dir.empty()){file="inlatvec.txt";}
  else {file=dir+"/inlatvec.txt";}
  fstream inlatvec;
  inlatvec.open(file.c_str(), ios::in);
  if (!inlatvec)
  {
    cout<<"File: "<<file<<" not opened!"<<endl;
    exit(1);
  }
  //inlatvec.ignore(1024,'\n');
  getline(inlatvec, name);
  inlatvec>>scale;
  for (int i=0; i<ndim;i++)
  {
    inlatvec.ignore(1024,'\n');
    mag=0;
    for (int j=0;j<ndim;j++)
    {
      inlatvec>>tempvec[j];
      tempvec[j]*=scale;
      mag+=(tempvec[j]*tempvec[j]);
    }
    vecs.push_back(tempvec);
    inv_vecs.push_back(tempvec);
    mag2.push_back(mag);
  }

  inlatvec>>sublat_count;//No. of sublattice
  //cout<<"sublat_count= "<<sublat_count<<endl;
  /*if (sublat_count!=num_sublat)
  { 
    cout<<"Error in read_lat_vec.cc: No. of sublattices differs from input.txt"<<endl;
    exit(1);
  }*/
  for (int i=0; i<sublat_count;i++)
  {
    for (int j=0;j<ndim;j++)
    {
      inlatvec>>tempvec[j];
    }
    basis.push_back(tempvec);
  }
  //cout<<"tempvec.size()= "<<tempvec.size()<<endl;
  if (inlatvec.fail())
  {
    cout<<"Error in read_lat_vec.cc: Error reading inlatvec.txt"<<endl;
    exit (1);
  } 
  inlatvec.close();
  Inversion dummy;
  dummy.invert_matrix(inv_vecs); 
  cal_volume();
  cout<<"lat_vec vol. = "<<volume<<endl;
  
  //Test by printing
  /*cout<<"lat_vec: "<<endl;
  for (int i=0; i<lat_vec.size();i++)
  {
    for (int j=0;j<lat_vec[i].size();j++)
    {
      cout<<lat_vec[i][j]<<" ";
    }
    cout<<" mag= "<<lat_vec_mag[i];
    cout<<endl;
    }*/
    
}
//EOF

