//This file is select_clus.cc
//Definition of member function select_clus() of class Lattice
//The func. selects the optimal no. of clusters 
//By Teck Leong Tan
extern Vlargenum;
int islimit(vector<int> nc, int n_index, Inversion& Inv);//Check if the cluster is proper
void select_clus(Inversion& Inv)
{
  fstream nc_input;
  //vector<int> nclimit;//Limit for no. of cluster for given n-body
  vector<int> nc;//No. of clusters for given n-body
  int n_index=2; //Index for n-body
  int n_limit=maxbody;
  double min_cv=Vlargenum;//Minimum CV score

  //Traversing Possible clusters--------------------------------------------------------------------
  
  //Zero and one-body clusters have only one f_index
  nc.assign(2,0);//And we start of with f_index=0 for 2-body clus.
  Inv.cal_cv1(nc);
  min_cv=Inv.cv1_score;  
  nclimit=nc;

  //The following explores the possible combinations of cluster in this manner:
  //First, we will increase the no. of possible nbody and when the n-limit is reached
  //we increase the f_index of the next highest possible nbody;
  //Also note that if the ith-body cannot be included, it also implies that this
  //ith-body cannot be included too when the f_index of the ith-1 body is increased
  //This form of exploration adheres to the CE procedure addressed in the paper:
  //Nikolai A.Z and D.D Johnson, Phys. Rev. Lett 92, No. 25 (2004)

  nc.push_back(0);
  while (!islimit(nc,2,Inv) && Inv.cv1_score<Verylargenum)
  {
    //Calculate CV score 
    Inv.cal_cv1(nc);
    if (Inv.cv1_score<mincv)
    {
      min_cv=Inv.cv1_score;
      nclimit=nc;
    }

    n_index++;//increase no. of nbody
    nc.push_back(0);
    if (nc.back()>nclimit[n_index]||n_index>n_limit)//if nlimit is reached
    {
      n_index--;//Advance to next highest nbody (nlimit -1)
      nc.pop_back();//Remove the f_index of nlimit
      nc[n_index]++;//Increase f_index of next highest nbody
      while(nc[n_index]>nclimit[n_index] && n_index>1)
      { //Keep on advancing to the next highest nbody if f-limit of the highest body is exceeded
        n_index--;
        nc.pop_back();
        nc[n_index]++;
      }  
    }  
    cout<<"iteration"<<++iteration<<":"<<endl;
    for (int i=0;i<nc.size();i++)
    {
      cout<<i<<"  "<<nc[i]<<endl;
    }  
  }//End while (nc[2]<=nclimit[2] )     
  nc[1]=0; //Reset 1-body f_index to 0, because nc[1]=1 at end of while loop.*/

