//This file is trans_vectors.h
//Declaration of class Trans_vectors.
//It stores Translation vectors
//By Teck Leong Tan

#ifndef _TRANS_VECTORS_H
#define _TRANS_VECTORS_H 
      
#include <string>
#include <vector>
#include<iostream>
#include <fstream>
#include "inversion.h"
using namespace std;

class Inversion;
class Trans_vectors
{
  public:
    void read_lat_vec (string const &dir, int ndim);
    void read_struct_vec (fstream &file, int ndim, Inversion  &inv);
    //The above func. reads from file and use a member func. in inv to invert matrix
    void insert_name(string str){name=str;};
    void clear_vecs(){vecs.clear(); inv_vecs.clear(); basis.clear();mag2.clear();}
    void cal_volume();//Calculate volume of cell. For ndim=1, length. ndim=2, area
    double dot_prod(const vector<double> &a, const vector<double> &b);
    void cross_prod( vector<double> a, vector<double> b, vector<double>& result);
    //The above does a cross product on 2 vectors and store it in result
    
    vector < vector<double> > vecs;//System of translation vectors. ndim by ndim
    vector < vector<double> > inv_vecs;//Inverse matrix of trans. vec. matrix
    vector <double> mag2;//Square of magnitude of each translation vector
    vector < vector<double> > basis;//Sublattice vectors
    //The above vectors are already scaled with the scale factor
    double scale;//Scale factor
    string name;//Name of the translation vectors e.g FCC, BCC
    double volume; //Volume of cell demarcated by the translation vectors
    //int dim;
};
#endif
//EOF
