//This file is "update_energy.cc"
//Func. definition of memeber func. of Lattice class
//By Teck Leong Tan

#include "lattice.h"

//This func. updates the energy of the system with new chem potential
//during monte carlo simulations

double Lattice::update_energy()
{ 
  double E0=E_struct.E;//E0 is initilaise to E of latest configuration
  //Loop over no. of atomic species
  for (int i=0;i<num_type;i++)
  {
    //Change due to new chem. potential
    //amount has i+1, as it includes amount of vacancies
    double delta=amount[i+1]*mu_increment[i];
    
    E0+=delta;
  }
  return E0;
}

//EOF

